#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xmu/WinUtil.h>
#include <stdio.h>
#include <stdlib.h>



static int 
ignore_error (Display *d, XErrorEvent *e)
{
  return 0;
}


int main(int argc, char **argv)
{

  int (*myold_handler) (Display *, XErrorEvent *);
  myold_handler= XSetErrorHandler (ignore_error);

     Display *dpy;  

     char result[100000];
        XWindowAttributes windowattr;


   dpy = XOpenDisplay(NULL);
   if (dpy == NULL)
     {
       fprintf(stderr, "Can't open display\n");
       return 1;
     }

     int scr = DefaultScreen (dpy);

    Window       root_return, parent_return;
    Window      *children = NULL;

Window   root = RootWindow (dpy, scr);

Window  client;

Atom            winNormalAtom = XInternAtom (dpy, "_NET_WM_WINDOW_TYPE_NORMAL", False);

    unsigned int nchildren, i;




    if (!XQueryTree (dpy, root, &root_return, &parent_return, &children,
			    &nchildren))
    {
	/* XQueryTree failed. */
	if (children)
	    XFree ((void *)children);
	return winNormalAtom;
    }




//Visual *visual;

sprintf( result , "./expose" );
    for (i = 1;i < argc;i++)
    {
   sprintf( result , "%s %s" , result ,  argv[i]);     
   }


    char *win_name;
    for (i = 0;i < nchildren;i++)
    {

	client = XmuClientWindow (dpy, children[i]);
//if (client != None ){

if (client != children[i] ){

        XGetWindowAttributes(dpy,client, &windowattr);


//if(XFetchName(dpy,children[i] , &win_name)){

if(windowattr.map_state == 2){
XFetchName(dpy,client , &win_name);
//printf("%x %s\n" , client , win_name);

sprintf( result , "%s 0x%lx \"%s\"" , result ,  client , win_name);

}
          //  printf("%x\n" ,children[i] );

    }

}
//printf("%s\n" , result);


//printf("+++%s\n" , result);
sprintf( result , "%s&" , result);
system(result);

    if (children)
	XFree ((void *)children);






XCloseDisplay(dpy);


    return(0);
}
